// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Pixmap.H>

#define XK_LATIN1
#define XK_MISCELLANY
#include <X11/keysymdef.h>
#include <X11/Xproto.h>

#include "Fake_Keyboard.h"

#define MAX_ZONES 3

class aqWindow : public Fl_Window
{
   public:
      aqWindow(int w, int h);

      void draw();
      int handle(int evt);
      int which_zone(int x, int y);
      int interpret_stroke();
      void draw_char(int ch, int cx, int cy);
      int* get_current_set();
      void change_mode(int mode);
      int check_special_char(int ch);
      void hit_key(int key);

   private:
      int last_zone_;
      int zone_ctr_;
      int zone_list_[MAX_ZONES];
      Fake_Keyboard* fake_keyboard_;
      int input_mode_;
      int input_lock_;
      Fl_Pixmap* letter_templates_[4];
      Fl_Pixmap* lock_image_;
      Fl_Pixmap* ctrl_image_;
      Fl_Pixmap* meta_image_;
      int meta_key_;
      int ctrl_key_;
};

